;;;
; MTS loader 1.5 by SolidSnake
;;;

;; Dialogs

dialog mts {
  title "MTS loader 1.5"
  size -1 -1 225 113
  option dbu
  list 1, 2 0 74 81, size
  text "Scheme:", 3, 4 84 24 8
  combo 4, 29 83 47 100, size drop
  box "", 5, 79 -2 144 4
  text "Preview: None", 12, 81 5 74 8
  box "", 13, 79 13 144 4
  icon 14, 79 20 145 73
  box "", 15, 2 95 221 4
  button "Preview", 16, 163 4 30 10
  button "Larger", 17, 193 4 30 10
  button "Load", 20, 171 101 25 10
  button "Unload", 21, 197 101 25 10
  text "No preview generated at the moment", 22, 83 49 138 8, center
  button "", 41, 0 0 0 0, hide ok
  menu "File", 6
  item "Add", 7, 6
  item "Edit", 8, 6
  item "Remove", 9, 6
  item break, 18, 6
  item "Add folder", 26, 6
  item "Clear list", 27, 6
  item break, 10, 6
  item "Info", 19, 6
  item break, 28, 6
  item "Close", 11, 6
  menu "Options", 2
  menu "Set path to", 35, 2
  item "MDX", 39, 35
  item "Popups", 40, 35
  item break, 36, 2
  item "Destroy previews", 37, 2
  item "Preview on click", 23, 2
  item "Clear windows on load/unload", 29, 2
  item "Minimize windows on load", 38, 2
  item break, 24, 2
  item "Advanced", 25, 2
  menu "Help", 30
  item "Readme", 32, 30
  item "Contents", 31, 30
  item break, 33, 30
  item "About", 34, 30
}

dialog mtsinfo {
  title "MTS loader 1.5 - info"
  size -1 -1 151 113
  option dbu
  box "", 1, 2 0 145 4
  text "Info on theme: N/A", 2, 4 5 145 8
  box "", 3, 2 11 145 4
  text "Name: N/A", 4, 4 19 141 8
  text "Author: N/A", 5, 4 29 141 8
  text "URL:", 7, 4 50 15 8
  link "N/A", 8, 22 49 123 8
  text "MTS Version: N/A", 9, 4 59 141 8
  text "Description:", 10, 4 69 42 8
  edit "N/A", 11, 2 79 147 32, read multi autovs
  text "E-Mail:", 12, 4 39 20 8
  link "N/A", 6, 25 39 120 8
  button "", 13, 0 0 0 0, hide ok
}

dialog mtsopt {
  title "MTS loader 1.5 - advanced options"
  size -1 -1 125 131
  option dbu
  box "", 1, 2 0 120 4
  text "When loading themes, apply:", 2, 4 6 90 8
  box "", 3, 2 13 120 4
  check "Pictures", 4, 4 19 63 10
  check "Colors", 5, 4 27 50 10
  check "Fonts", 6, 4 35 50 10
  check "Nick colors", 7, 74 27 50 10
  check "Timestamp", 8, 74 19 50 10
  box "", 9, 2 45 120 4
  text "When a theme is loaded, hide:", 10, 4 51 90 8
  box "", 11, 2 58 120 4
  check "Welcome messages", 13, 4 64 62 10
  check "Stats (/lusers)", 14, 4 72 60 10
  check "Nicks (/names)", 15, 74 64 64 10
  check "Channel info", 16, 74 73 48 10
  box "", 17, 2 82 120 4
  button "Ok", 18, 65 120 28 9, ok
  button "Cancel", 19, 94 120 28 9, cancel
  box "", 21, 2 95 120 4
  combo 22, 59 102 50 100, size drop
  button "", 23, 111 102 10 10
  check "Use custom nicklist colors", 20, 4 88 95 8
  text "Status:", 25, 4 103 19 8
  box "", 26, 2 113 120 4
}

dialog preaux {
  title "MTS loader 1.5"
  size -1 -1 175 61
  text "", 1, 25 9 120 16, center
  text "", 2, 9 33 152 16
  button "", 3, 0 0 0 0, hide Ok
}

dialog lpre {
  title "MTS loader 1.5"
  size -1 -1 518 342
  option pixels
  box "", 1, 4 2 510 8
  text "Preview:", 2, 8 14 216 16, disable
  box "", 3, 4 28 510 8
  icon 4, 9 41 499 295
  button "", 5, 0 0 0 0, hide ok
}

dialog colors {
  title "Colors"
  size -1 -1 96 34
  option dbu
  button "", 1, 4 7 10 10
  button "", 2, 15 7 10 10
  button "", 3, 26 7 10 10
  button "", 4, 37 7 10 10
  button "", 5, 48 7 10 10
  button "", 6, 59 7 10 10
  button "", 7, 70 7 10 10
  button "", 8, 81 7 10 10
  button "", 9, 4 18 10 10
  button "", 10, 15 18 10 10
  button "", 11, 26 18 10 10
  button "", 12, 37 18 10 10
  button "", 13, 48 18 10 10
  button "", 14, 59 18 10 10
  button "", 15, 70 18 10 10
  button "", 16, 81 18 10 10
  box "", 17, 2 0 92 4
  box "", 18, 2 28 92 4
  button "", 19, 0 0 0 0, hide result
  button "", 20, 0 0 0 0, hide ok
}

;; Events

on *:dialog:mts:*:*: { 
  if ($devent == init) {
    setmtsmdx
    mtsmdx SetControlMDX $dname 1 listview rowselect report single showsel > $mtsviews
    mtsmdx SetBorderStyle $dname 16,17 clientedge
    mtsmdx SetFont $dname 12 ANSI 13 700 Tahoma
    did -i $dname 1 1 headerdims 127
    did -i $dname 1 1 headertext Themes:
    did -b mts 12
    var %i = 1
    while ($read($mts.path(mts.tl),n,%i)) {
      if ($isfile($read($mts.path(mts.tl),n,%i))) {
        did -a mts 1 $nopath($read($mts.path(mts.tl),n,%i))
        inc %i
      }
      else write -dl %i $mts.path(mts.tl)
    }
    if ($did(mts,1,2)) {
      did -c mts 1 2
      dm 1
    }
    if ($isfile($mtsret(main,preview))) {
      var %t = $mtsret(main,preview)
      showpre " $+ %t $+ "
      if ($didwm($dname,1,* 0 0 0 $deltok($nopath(%t),-1,45),1)) {
        did -c $dname 1 $ifmatch
        dm $calc($ifmatch - 1)
        var %t = $remlast($gettok($nopath(%t),-1,45),4)
        did -c $dname 4 $iif(%t == mts,1,$calc($remove(%t,scheme) + 1))
      }
    }
    else did -b mts 37
    mtsinil click 23
    mtsinil clear 29
    mtsinil minimize 38
    if (!$mtsh(current)) did -b mts 21
  }
  elseif ($devent == sclick) {
    if ($did == 1) && ($did(mts,1).sel) {
      var %t = $gettok($did(mts,1,1).text,1,32)
      if (%t == item) {
        dm $calc($did(mts,1).sel - 1)
        if ($did(mts,23).state) mtspre $mpre(small)
      }
      elseif (%t == rclick) mtspop
    }
    elseif ($did == 4) && ($did(mts,1).sel) && ($did(mts,23).state) mtspre $mpre(small)
    elseif ($did == 16) {
      if ($did(mts,1).sel) mtspre $mpre(small)
    }
    elseif ($did == 17) && ($did(mts,1).sel) mtspre $mpre(large)
    elseif ($did == 20) && ($did(mts,1).sel) mtsload $sch $read($mts.path(mts.tl),n,$calc($did(mts,1).sel - 1))
    elseif ($did == 21) mtsunload
  }
  elseif ($devent == menu) {
    if ($did == 7) mtsadd
    elseif ($did == 8) mtsedit
    elseif ($did == 9) mtsdel
    elseif ($did == 19) {
      if ($did(mts,1).sel) mtsinfo $+(",$read($mts.path(mts.tl),n,$calc($did(mts,1).sel - 1)),")
    }
    elseif ($did == 11) dialog -x mts
    elseif ($did == 25) mtsopt
    elseif ($did == 26) {
      var %dir = $$sdir(mts,Chosse a folder containing MTS themes,Ok)
      var %i = 1
      while ($findfile(%dir,*.mts,%i)) {
        var %f = $findfile(%dir,*.mts,%i)
        if (!$read($mts.path(mts.tl),wn,%f)) {
          write $mts.path(mts.tl) %f
          did -a mts 1 $nopath(%f)
        }
        inc %i
      }
      if ($did(mts,1,2)) {
        did -c mts 1 %i
        dm $calc($did(mts,1).sel - 1)
      }
    }
    elseif ($did == 27) {
      write -c $mts.path(mts.tl)
      did -r mts 1
      clearinfo
    }
    elseif ($did == 39) setmdxpath
    elseif ($did == 40) setpoppath
    elseif ($did == 23) mtsini click 23
    elseif ($did == 29) mtsini clear 29
    elseif ($did == 38) mtsini minimize 38
    elseif ($did == 37) {
      did -ra mts 12 Preview: None
      did -b mts 37
      while ($findfile($scriptdir $+ large,*,1)) .remove " $+ $ifmatch $+ "
      while ($findfile($scriptdir $+ small,*,1)) .remove " $+ $ifmatch $+ "
      did -h mts 14
      did -v mts 22
    }
    elseif ($did == 32) run notepad.exe $mts.path(readme.txt)
    elseif ($did == 31) mtshelp
    elseif ($did == 34) var %n = $input(MTS loader 1.5 written by SolidSnake,oi,MTS loader)
  }
}

on *:dialog:mtsinfo:*:*: { 
  if ($devent == init) {
    setmtsmdx
    mtsmdx SetFont $dname 2 ANSI 13 700 Tahoma
    mtsmdx SetBorderStyle $dname 11 staticedge
    did -b mtsinfo 2
  }
  elseif ($devent == sclick) {
    if ($did == 6) run mailto: $+ $did(mtsinfo,6).text
    elseif ($did == 8) {
      var %t = $did(mtsinfo,8).text
      run $iif(http:// isin %t,%t, http:// $+ %t)
    }
  }
}

on *:dialog:mtsopt:*:*: { 
  if ($devent == init) {
    setmtsmdx
    mtsmdx SetControlMDX $dname 23 Text > $mtsctl_gen
    mtsmdx SetBorderStyle $dname 23 clientedge
    mtsmdx SetFont $dname 2,10 ANSI 13 700 Tahoma
    did -b mtsopt 2,10
    optaux2 yourself
    optaux2 owner
    optaux2 op
    optaux2 hop
    optaux2 voice
    optaux2 regular
    optaux2 notify
    optaux2 protect
    optaux2 autoop
    optaux2 autovoice
    optaux2 ignore
    did -c mtsopt 22 1
    optaux3 yourself
    optaux pictures 4
    optaux colors 5
    optaux fonts 6
    optaux nicks 7
    optaux timestamp 8
    optaux welcome 13
    optaux lusers 14
    optaux names 15
    optaux chaninfo 16
    optaux nickcolors 20
  }
  elseif ($devent == sclick) {
    if ($did == 22) optaux3 $did($did).seltext
    elseif ($did == 23) {
      var %c = $stdc
      var %t = $did(mtsopt,22).seltext
      hadd mtsopt %t %c
      optaux3 %t
    }
    elseif ($did == 18) {
      optaux4 pictures 4
      optaux4 colors 5
      optaux4 fonts 6
      optaux4 nicks 7
      optaux4 timestamp 8
      optaux4 welcome 13
      optaux4 lusers 14
      optaux4 names 15
      optaux4 chaninfo 16
      optaux4 nickcolors 20
      optaux5 yourself
      optaux5 owner
      optaux5 op
      optaux5 hop
      optaux5 voice
      optaux5 regular
      optaux5 notify
      optaux5 protect
      optaux5 autoop
      optaux5 autovoice
      optaux5 ignore
    }
  }
}

on *:dialog:preaux:*:*:{
  if ($devent == init) {
    setmtsmdx
    mtsmdx SetControlMDX $dname 2 progressbar smooth > $mtsctl_gen
  }
}

on *:dialog:lpre:init:*:{
  setmtsmdx
  mtsmdx SetFont $dname 2 ANSI 13 700 Tahoma
}

on *:dialog:colors:*:*: { 
  if ($devent == init) {
    setmtsmdx
    mtsmdx SetBorderStyle $dname 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16 clientedge
    mtsmdx SetControlMDX $dname 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16 Text > $mtsctl_gen
    mtsmdx SetDialog $dname style 0 title
    var %i = 1
    while (%i <= 16) {
      mtsmdx SetColor $dname %i background $color($calc(%i - 1))
      inc %i
    }
  }
  elseif ($devent == sclick) {
    if ($did >= 1) && ($did <= 16) {
      did -a $dname 19 $calc($did - 1)
      dialog -k colors
    }
  }
}

on *:START:{
  if ($isfile($mtsh(script))) && (!$script($mtsh(script))) .load -rs $shortfn($mtsh(script))
  if (!$isdir($scriptdir $+ small)) .mkdir " $+ $scriptdir $+ small $+ "
  if (!$isdir($scriptdir $+ large)) .mkdir " $+ $scriptdir $+ large $+ "
  hmake mts 20
  hload mts $mts.path(mts.ah)
  if ($mtsh(timestampformat)) .timestamp -f $ifmatch
}

on *:LOAD:{
  echo -s This is MTS loader v1.5 written by SolidSnake (liquidsnake@sapo.pt)
  echo -s type /mts to display the main MTS loader dialog box
  echo -s To know more about this theme loader and it's commands available, type /mtshelp
  if ($version < 6.03) || ($version > 6.1) echo -s This addon is meant to mIRC 6.03 and 6.1. It may not work as it should on this version ( $+ $version $+ )
  writeini $mts.path(mts.ini) main mdx $remove($scriptdir,$mircdir) $+ MDX\
  writeini $mts.path(mts.ini) main popups $remove($scriptdir,$mircdir) $+ popups.dll
}

on *:UNLOAD:mtsunload

on ^&*:CHAT:*:{
  if ($mts.event(textquery)) {
    mtsvars echo $color(normal) -mlt = $+ $nick
    set -nu %::nick $nick
    set -nu %::address $iif($address,$ifmatch,N/A)
    set -nu %::text $1-
    set -u %::cnick $cnick($nick).color
    set -nu %::nick $+(,%::cnick,$nick,)
    theme.text
  }
}

on ^&*:TEXT:*:*:mts.tan $1-

on ^&*:ACTION:*:*:mts.tan $1-

on ^&*:NOTICE:*:*:mts.tan $1-

on &*:INPUT:?:mts.inp $1-

on &*:INPUT:=:mts.inp $1-

on &*:INPUT:#:mts.inp $1-

on ^*:NOTIFY:uno

on ^*:UNOTIFY:uno

on ^&*:JOIN:#:tjp $event $+ $iif($nick == $me,self)

on ^&*:PART:#:if ($nick != $me) tjp $event $1-

on ^&*:NICK:{
  if ($mts.event($iif($nick == $me,nickself,nick))) {
    set -nu %::nick $nick
    set -nu %::newnick $newnick
    set -nu %::address $iif($address,$ifmatch,N/A)
    loopt $newnick
  }
}

on ^&*:QUIT:{
  if ($mts.event(quit)) {
    set -nu %::nick $nick
    set -nu %::address $iif($address != $null,$ifmatch,N/A)
    set -nu %::text $1-
    loopt $nick
  }
}

ctcp &*:*:*:{
  if ($mts.event($iif($chan,ctcpchan,ctcp))) {
    if ($1 == VERSION) || ($1 == DCC) return
    mtsvars echo $color(ctcp) -at
    set -nu %::nick $nick
    set -nu %::address $iif($address,$ifmatch,N/A)
    set -nu %::chan $chan
    set -nu %::ctcp $1
    set -nu %::text $2-
    if ($1 == PING) set -un %reply $2-
    elseif ($1- == TIME) set -un %reply $fulldate
    elseif ($1- == FINGER) set -un %reply $fullname ( $+ $emailaddr $+ ) Idle $idle second(s) $readini(mirc.ini,text,finger)
    if (%reply) .ctcpreply $nick $1 %reply
    theme.text
  }
}

on &*:CTCPREPLY:*:{
  if ($mts.event(ctcpreply)) {
    mtsvars echo $color(ctcp) -at
    set -nu %::nick $nick
    set -nu %::chan $chan
    set -nu %::ctcp $1
    if ($1 == ping) set -nu %::text $calc($ctime - $2) sec(s)
    else set -nu %::text $2-
    theme.text
  }
}

on &*:DNS:{
  var %t = $iif($dns(0) > 0,dnsresolve,dnserror)
  if ($mts.event(%t)) {
    mtsvars echo $color(other) -a
    set -nu %::nick $nick
    set -nu %::address $address
    set -nu %::iaddress $iaddress
    set -nu %::naddress $naddress
    if (%t == dnsresolve) {
      var %i = 1
      while ($dns(%i)) {
        set -nu %::address $dns(%i).ip
        set -nu %::raddress $dns(%i)
        theme.text
        inc %i
      }
    }
    else theme.text
  }
}

on ^&*:USERMODE:{
  if ($mts.event(modeuser)) {
    mtsvars echo $color(mode) -s
    set -nu %::nick $nick
    set -nu %::modes $1-
    theme.text
  }
}

on ^&*:ERROR:*:{
  if ($mts.event(servererror)) {
    mtsvars echo $color(info) -st
    set -nu %::text $1-
    theme.text
    halt
  }
}

on ^&*:INVITE:#:{
  if ($mts.event($event)) {
    mtsvars echo $color(invite) -at
    set -nu %::nick $nick
    set -nu %::address $iif($address != $null,$ifmatch,N/A)
    set -nu %::chan $chan
    set -nu %::text $1-
    theme.text
  }
}

on ^&*:SNOTICE:*:{
  if ($mts.event(noticeserver)) {
    mtsvars echo $color(info) -st
    set -nu %::nick $nick
    set -nu %::address $iif($address != $null,$ifmatch,N/A)
    set -nu %::text $1-
    theme.text
  }
}

on ^&*:WALLOPS:*:{
  if ($mts.event($event)) {
    mtsvars echo  $color(wallops) -st
    set -nu %::nick $nick
    set -nu %::address $iif($address != $null,$ifmatch,N/A)
    set -nu %::text $1-
    theme.text
  }
}

on ^&*:RAWMODE:#:{
  if ($mts.event(mode)) {
    mtsvars echo $color(mode) -t $chan
    set -u %::nick $nick
    set -u %::address $iif($address,$ifmatch,N/A)
    set -u %::chan $chan
    set -u %::modes $1-
    theme.text
  }
}

on ^&*:TOPIC:#:{
  if ($mts.event($event)) {
    mtsvars echo $color(topic) -t $chan
    set -u %::nick $nick
    set -u %::address $iif($address,$ifmatch,N/A)
    set -u %::chan $chan
    set -u %::text $1-
    theme.text
  }
}

on ^&*:KICK:#:{
  var %t = $iif($knick == $me,kickself,$event)
  if ($mts.event(%t)) {
    mtsvars echo $color(topic) $iif(%t == kickself,$iif($window($chan),-t $chan,-st),-t $chan)
    set -u %::nick $nick
    set -u %::address $iif($address,$ifmatch,N/A)
    set -u %::chan $chan
    set -u %::knick $knick
    set -u %::kaddress $iif($address($knick,5),$ifmatch,N/A)
    set -u %::text $1-
    theme.text
  }
}

raw 001:*:{
  if ($gettok($readini(mirc.ini,options,n1),11,44) == 1) hadd -m motd $cid 1
  if ($mtsret(options,lusers)) hadd -m lusers $cid 1
  raw.aux -s $2-
}

raw 372:*:{
  if ($hget(motd,$cid)) halt
  raw.aux -s $2-
}

raw 375:*:{
  if ($hget(motd,$cid)) halt
  raw.aux -s $2-
}

raw 376:*:{
  if ($hget(motd,$cid)) {
    hdel motd $cid
    halt
  }
  raw.aux -s $2-
}

raw 474:*:raw.aux -a $2-

raw 421:*:raw.aux -a $2-

raw 315:*:raw.aux -a $2-

raw 367:*:raw.aux -a $2-

raw 368:*:raw.aux -a $2-

raw 366:*:{
  if ($hget(join,names. $+ $2 $+ $cid) == 1) && ($mtsh(current)) {
    hdel join names. $+ $2 $+ $cid
    halt
  }
  if ($hget(join,chaninfo. $+ $2 $+ $cid) == 1) && ($mtsh(current)) {
    hdel join chaninfo. $+ $2 $+ $cid
    halt
  }
  raw.aux -s $2-
}

raw 332:*:{
  if ($mtsh(current)) && (!$halted) {
    if ($hget(join,$+(topic.,$2,$cid))) halt
    mtsvars echo $color(join) -t $2  $+ $chr(9) $+ $3-
    set -u %::chan $2
    set -u %::nick $2
    set -u %::nick $2
    theme.text $+(raw.,$numeric)
    halt
  }
}

raw 352:*:{
  if ($mtsh(current)) && (!$halted) {
    mtsvars echo $color(other) -a $+ $chr(9) $+ $2-
    set -u %::nick $6
    set -u %::address $3 $+ @ $+ $4
    set -u %::wserver $5
    set -u %::away $iif(h isin $7,h,g)
    set -u %::cmode $iif(. isin $7,.,$iif(@ isin $7,@,$iif(% isin $7,%,$iif(+ isin $7,+))))
    set -u %::isoper is $iif(* !isin $7,not)
    set -u %::value $8
    set -u %::realname $9-
    set -u %::text $3-
    theme.text $+(raw.,$numeric)
    halt
  }
}

raw 333:*:{
  if ($mtsh(current)) && (!$halted) {
    if ($hget(join,$+(topic.,$2,$cid))) {
      hdel join $+(topic.,$2,$cid)
      halt
    }
    mtsvars echo $color(join) -t $2 $+ $chr(9) $+ $2-
    set -u %::nick $3
    set -u %::value $4
    set -u %::text $asctime($4)
    theme.text $+(raw.,$numeric)
    halt
  }
}

raw 353:*:{
  if ($mtsh(current)) && (!$halted) {
    if ($hget(join,names. $+ $3 $+ $cid)) halt
    mtsvars echo $color(other) -s $+ $chr(9) $+ $2-
    set -u %::chan $3
    set -u %::text $4-
    theme.text $+(raw.,$numeric)
    halt
  }
}

raw 329:*:{
  if ($mtsh(current)) && (!$halted) {
    if ($mtsret(options,chaninfo)) halt
    mtsvars echo $color(join) -t $2 $+ $chr(9) $+ $2-
    set -u %::value $3
    set -u %::text $asctime($3)
    theme.text $+(raw.,$numeric)
    halt
  }
}

raw 324:*:{
  if ($mtsh(current)) && (!$halted) {
    if ($mtsret(options,chaninfo)) halt
    mtsvars echo $color(join) -t $2 $+ $chr(9) $+ $2-
    set -u %::modes $3
    theme.text $+(raw.,$numeric)
    halt
  }
}

raw 341:*:{
  if ($mtsh(current)) && (!$halted) {
    mtsvars echo $color(other) -s $+ $chr(9) $+ $2-
    set -u %::nick $2
    set -u %::chan $3
    theme.text $+(raw.,$numeric)
    halt
  }
}

raw 251:*:{
  if ($mtsh(current)) && (!$halted) {
    if ($hget(lusers,$cid)) halt
    mtsvars echo $color(other) -s $+ $chr(9) $+ $2-
    set -u %::users $4
    set -u %::text $6
    set -u %::value $11
    theme.text $+(raw.,$numeric)
    halt
  }
}

raw 255:*:raw.aux2 3 6 $2-

raw 265:*:raw.aux2 4 6 $2-

raw 266:*:raw.aux2 4 6 $2-

raw 332:*:{
  if ($mtsh(current)) && (!$halted) {
    mtsvars echo $color(join) -t $2 $+ $chr(9) $+ $2-
    set -u %::text $3-
    theme.text $+(raw.,$numeric)
    halt
  }
}

raw 302:*:{
  if ($mtsh(current)) && (!$halted) {
    mtsvars echo $color(other) -a $+ $chr(9) $+ $2-
    set -u %::nick $remove($gettok($2,1,61),-,*)
    set -u %::address $remove($gettok($2,2,61),-,*)
    theme.text $+(raw.,$numeric)
    halt
  }
}

raw 311:*:{
  if ($mtsh(current)) && (!$halted) {
    hadd -m $+(whois.,$2,$cid) $numeric $3-
    if ($mtsget($mtsh(current),raw.311)) {
      mtsvars echo $color(whois) -a $+ $chr(9) $+ $2-
      set -u %::nick $2
      set -u %::address $3 $+ @ $+ $4
      set -u %::realname $6-
      set -u %::country $country($4)
      theme.text $+(raw.,$numeric)
    }
    halt
  }
}

raw 314:*:{
  if ($mtsh(current)) && (!$halted) {
    hadd -m $+(whois.,$2,$cid) $numeric $3-
    if ($mtsget($mtsh(current),raw.314)) {
      mtsvars echo $color(whois) -a $+ $chr(9) $+ $2-
      set -u %::nick $2
      set -u %::address $3 $+ @ $+ $4
      set -u %::realname $6-
      set -u %::country $country($4)
      theme.text $+(raw.,$numeric)
    }
    halt
  }
}

raw 301:*:{
  if ($mtsh(current)) && (!$halted) {
    hadd -m $+(whois.,$2,$cid) $numeric $3-
    if ($mtsget($mtsh(current),raw.301)) {
      mtsvars echo $color(whois) -a $+ $chr(9) $+ $3-
      set -u %::nick $2
      set -u %::away $3-
      theme.text $+(raw.,$numeric)
    }
    halt
  }
}

raw 307:*:{
  if ($mtsh(current)) && (!$halted) {
    hadd -m $+(whois.,$2,$cid) $numeric is
    if ($mtsget($mtsh(current),raw.307)) {
      mtsvars echo $color(whois) -a $+ $chr(9) $+ $2-
      set -u %::nick $2
      set -u %::isregd is
      theme.text $+(raw.,$numeric)
    }
    halt
  }
}

raw 317:*:{
  if ($mtsh(current)) && (!$halted) {
    hadd -m $+(whois.,$2,$cid) $numeric $3-
    if ($mtsget($mtsh(current),raw.317)) {
      mtsvars echo $color(whois) -a $+ $chr(9) $+ $2-
      set -u %::nick $2
      set -u %::idletime $3
      set -u %::signontime $asctime($4)
      theme.text $+(raw.,$numeric)
    }
    halt
  }
}

raw 319:*:{
  if ($mtsh(current)) && (!$halted) {
    hadd -m $+(whois.,$2,$cid) $hget($+(whois.,$2,$cid),$numeric) $numeric $3-
    if ($mtsget($mtsh(current),raw.319)) {
      mtsvars echo $color(whois) -a $+ $chr(9) $+ $2-
      set -u %::nick $2
      set -u %::chan $3-
      theme.text $+(raw.,$numeric)
    }
    halt
  }
}

raw 312:*:{
  if ($mtsh(current)) && (!$halted) {
    hadd -m $+(whois.,$2,$cid) $numeric $3-
    if ($mtsget($mtsh(current),raw.312)) {
      mtsvars echo $color(whois) -a $+ $chr(9) $+ $2-
      set -u %::nick $2
      set -u %::wserver $3
      set -u %::serverinfo $4-
      theme.text $+(raw.,$numeric)
    }
    halt
  }
}

raw 313:*:{
  if ($mtsh(current)) && (!$halted) {
    hadd -m $+(whois.,$2,$cid) $numeric $3-
    if ($mtsget($mtsh(current),raw.313)) {
      mtsvars echo $color(whois) -a $+ $chr(9) $+ $2-
      set -u %::nick $2
      set -u %::isoper is
      set -u %::operline $3-
      theme.text $+(raw.,$numeric)
    }
    halt
  }
}

raw 315:*:raw.aux3 $1-

raw 316:*:raw.aux3 $1-

raw 330:*:raw.aux3 $1-

raw 378:*:raw.aux3 $1-

raw 309:*:raw.aux3 $1-

raw 308:*:raw.aux3 $1-

raw 378:*:raw.aux3 $1-

raw 379:*:raw.aux3 $1-

raw 310:*:raw.aux3 $1-

raw 441:*:raw.aux4

raw 443:*:raw.aux4

raw 318:*:aux.318.369 $1-

raw 369:*:aux.318.369 $1-

raw *:*:{
  if ($halted) return
  if ($hget(lusers,$cid)) && ($numeric >= 252) && ($numeric <= 254) && ($mtsh(current)) halt
  if (!$istok(600.601.602.603.604.605.606.321.322.323.364.365,$numeric,46)) raw.aux $iif($numeric == 306,-s,$iif($numeric == 305,-s,-a)) $2-
}

;; Commands & identifiers

alias mts if (!$dialog(mts)) dialog -m mts mts

alias -l stdc return $dialog(colors,colors)

alias -l mtsmdx dll " $+ $mtsret(main,mdx) $+ mdx.dll $+ " $1-

alias -l mtsviews return $mtsret(main,mdx) $+ views.mdx

alias -l mtsctl_gen return $mtsret(main,mdx) $+ ctl_gen.mdx

alias setmtsmdx {
  mtsmdx SetMircVersion $version
  mtsmdx MarkDialog $dname $dialog($dname).hwnd
}

alias mtspopups  {
  var %t = $mtsret(main,popups)
  if ($isid) return $dll(%t,$1,$2)
  else dll " $+ %t $+ " $1-
}

alias -l remfirst return $right($1,$calc($len($1) - $2))

alias -l remlast return $left($1,$calc($len($1) - $2))

alias mtsinfo {
  if (!$dialog(mtsinfo)) dialog -hm mtsinfo mtsinfo  
  did -ra mtsinfo 2 Info on theme: $nopath($1-)
  did -ra mtsinfo 4 Name: $mtsinfo.aux($1-,name) $mtsget($1-,version)
  did -ra mtsinfo 5 Author: $mtsinfo.aux($1-,author)
  did -ra mtsinfo 6 $mtsinfo.aux($1-,email)
  did -ra mtsinfo 8 $mtsinfo.aux($1-,website)
  did -ra mtsinfo 9 MTS Version: $mtsinfo.aux($1-,mtsversion)
  did -ra mtsinfo 11 $mtsinfo.aux($1-,description)
}

alias mtsopt if (!$dialog(mtsopt)) dialog -hm mtsopt mtsopt

alias -l mtsadd {
  var %dir = $$sfile(mts\ $+ *.mts,Choose an MTS theme,Ok)
  if (!$read($mts.path(mts.tl),wn,%dir)) {
    write $mts.path(mts.tl) %dir
    did -ac mts 1 $nopath(%dir)
    dm $calc($did(mts,1).sel - 1)
  }
}

alias -l mtsedit if ($did(mts,1).sel) .run notepad.exe $read($mts.path(mts.tl),n,$calc($ifmatch - 1))

alias -l mtsdel {
  if ($did(mts,1).sel) {
    var %t = $ifmatch
    did -d mts 1 %t
    write -dl $calc(%t - 1) $mts.path(mts.tl)
    if ($did(mts,1,2)) {
      if ($did(mts,1).lines >= %t) did -c mts 1 %t
      else did -c mts 1 $calc(%t - 1)
      dm $calc($did(mts,1).sel - 1)
    }
    else clearinfo
  }
}

alias country {
  if ($1) {
    if ($readini($mts.path(country.ini),country,$gettok($1,-1,46))) return $ifmatch
    elseif ($gettok($1,1,46) == 127) return Fake Host
    elseif ($remove($1,.) isnum) return Numeric IP
    else return N/A
  }
}

alias mts.version return 1.3

alias mtsget {
  if ($2) {
    if ($1 isnum) return $read($read($mts.path(mts.tl),$1),s,$2)
    else return $read($1,s,$2)
  }
}

alias mtshelp run $mts.path(contents.htm)

alias mtspre {
  if ($isfile($3-)) {
    var %fpreview = $mts.path($1 $+ \ $+ $nopath($3-) $+ - $+ $2 $+ .bmp)
    if ($isfile(%fpreview)) {
      $iif($1 == small,showpre,showprel) %fpreview
      return
    }
    dialog -hm preaux preaux
    did -a preaux 1 Loading MTS preview
    mtssch $2-
    if ($isfile($mts.path(preview.mts))) .remove $mts.path(preview.mts)
    .savebuf @mtsp1 $mts.path(preview.mts)
    window -c @mtsp1
    if ($window(@mtsp2)) window -c @mtsp2
    var %f = $mts.path(preview.mts)
    set -u %p.colors $mtsget(%f,colors)
    if (!%p.colors) set -u %p.colors $cdef
    set -u %p.basecolors $mtsget(%f,basecolors)
    set -u %p.rgbcolors $mtsget(%f,rgbcolors)
    if (!%p.rgbcolors) set -u %p.colors $rgbdef
    set -u %p.fontchan $mtsget(%f,fontchan)
    set -u %p.clinecharop $mtsget(%f,clinecharop)
    set -u %p.clinecharvoice $mtsget(%f,clinecharvoice)
    set -u %p.parentext $mtsget(%f,parentext)
    set -u %p.clineme $mtsget(%f,clineme)
    set -u %p.clineop $mtsget(%f,clineop)
    set -u %p.clinevoice $mtsget(%f,clinevoice)
    if ($mtsget(%f,basecolors)) {
      set -u %::c1  $+ $gettok(%p.basecolors,1,44)
      set -u %::c2  $+ $gettok(%p.basecolors,2,44)
      set -u %::c3  $+ $gettok(%p.basecolors,3,44)
      set -u %::c4  $+ $gettok(%p.basecolors,4,44)
    }
    set -u %p.script $shortfn($nofile($3-) $+ $mtsget(%f,script))
    set -u %::pre $mtspre.aux($mtsget(%f,prefix))
    set -u %::parentext $mtspre.aux($mtsget(%f,parentext))
    set -u %::timestamp $mtspre.aux($mtsget(%f,timestamp))
    set -u %::timestampformat $time($mtspre.aux($mtsget(%f,timestampformat)))
    if ($isfile(%p.script)) && (!$script(%p.script)) {
      .load -rs %p.script
      var %unload = 1
    }
    if (%::timestamp != off) && (%::timestamp != on) && (%::timestamp) set -u %::timestampformat $time(%::timestamp)
    if (!%::timestampformat) set -u %::timestampformat $time((HH:nn))
    set -u %pre.ts $iif(%::timestamp,$ifmatch,off)
    set -u %::timestamp %::timestampformat
    if ($window(@pretext)) window -c @pretext
    window -h @pretext
    set -u %::me $+(,%p.clineme,$me,)
    set -u %::chan #anaconda
    set -u %::nick PPK
    set -u %::address Anaconda@script.pt
    set -u %::text See you later!
    set -u %::modes +v $me
    set -u %::ctcp PING
    mtspre.aux2 8 joinself %f
    mtspre.aux2 8 join %f
    mtspre.aux2 17 part %f
    set -u %::nick SolidSnake
    mtspre.aux2 10 mode %f
    set -u %::nick $+(,%p.clineop,SolidSnake)
    set -u %::cmode $iif(%p.clinecharop,$+(,$ifmatch,),@)
    set -u %::text Grettings my friend
    mtspre.aux2 12 textchan %f
    set -u %::nick $+(,%p.clineop,Allowed)
    set -u %::text getting boring from this channel
    mtspre.aux2 2 actionchan %f
    set -u %::nick Saviola
    set -u %::text $ctime
    mtspre.aux2 3 ctcp %f
    set -u %::cmode $iif(%p.clinecharvoice,$+(,$ifmatch,),+)
    set -u %::text What channel is this?
    mtspre.aux2 16 textchanself %f
    set -u %::text Quit: Anything that can go wrong, will go wrong
    mtspre.aux2 18 quit %f
    set -u %::nick [MissManson]
    set -u %::chan #hot
    mtspre.aux2 7 invite %f
    set -u %::nick EletroXok
    set -u %::text Hello, why don't you join #Patrimonio_Bar?
    mtspre.aux2 13 notice %f
    if ($1 != small) {
      set -u %::nick SolidSnake
      set -u %::newnick LiquidSnake
      set -u %::chan #anaconda
      set -u %::text I don't like your nick!
      mtspre.aux2 9 kickself %f
      mtspre.aux2 8 joinself %f
      mtspre.aux2 11 nick %f
      set -u %::text MTS loader 1.5 for mIRC 6.03 & 6.1
      set -u %::nick LiquidSnake
      mtspre.aux2 19 topic %f
      set -u %::value SolidSnake
      set -u %::fromserver $nick
      set -u %::isoper is not
      set -u %::isregd is not
      set -u %::realname Classified
      set -u %::country $country(pt)
      set -u %::isregd is
      set -u %::idletime 47
      set -u %::signontime $asctime($ctime)
      set -u %::wserver irc.ptnet.org
      set -u %::serverinfo Portuguese IRC server
      set -u %::isoper is not
      if ($mtsget(%f,whois)) {
        set -u %::numeric 318
        var %p.whois = $theme.parse($ifmatch)
        set -u %:echo aline @pretext 21
        if ($gettok(%p.whois,1,32) == !script) $gettok(%p.whois,2-,32)
        else aline @pretext 21 %p.whois
      }
      else {
        set -u %::numeric 311
        mtspre.aux2 21 raw.311 %f
        set -u %::numeric 307
        mtspre.aux2 21 raw.307 %f
        set -u %::numeric 319
        mtspre.aux2 21 raw.319 %f
        set -u %::numeric 312
        mtspre.aux2 21 raw.312 %f
        set -u %::numeric 317
        mtspre.aux2 21 raw.317 %f
        set -u %::numeric 318
        mtspre.aux2 21 raw.318 %f
      }
    }
    if ($window(@preview)) window -c @preview
    window -Bph +d @preview -1 -1 $iif($1 == small,280 146,499 290)
    drawfill @preview $gettok(%p.colors,1,44) $gettok(%p.colors,1,44) 1 1
    var %preback = $gettok(%p.colors,1,44)
    var %prefont = " $+ $gettok(%p.fontchan,1,44) $+ "
    var %presize = $gettok(%p.fontchan,2,44)
    var %i = 1
    while ($line(@pretext,%i)) {
      var %precolor = $gettok($ifmatch,1,32)
      var %preline = $gettok($ifmatch,2-,32)
      drawtext -pb @preview $gettok(%p.colors,%precolor,44) %preback %prefont %presize 3 $iif(%i != 1,$calc(1 + ((%i - 1) * $height(%preline,%prefont,%presize))),1) $iif(%pre.ts != off,%::timestamp) %preline
      inc %i
    }
    var %i = 1
    while (%i <= 16) {
      var %o = $color($calc(%i - 1)).rgb
      var %rgbr = $gettok(%p.rgbcolors,%i,32)
      var %r = $rgb( [ %rgbr ] )
      var %rgbo = $iif($mtsh(rgbcolors),$ifmatch,$rgbdef)
      if ($istok(%rgbo,%rgbr,32)) && (%o != %r) {
        var %rgbs = 0
        while (1) {
          if (!$istok(%rgbo,$rgb(%rgbs),32)) && (!$istok(%p.rgbcolors,$rgb(%rgbs),32)) && (!$istok(%rgba,$rgb(%rgbs),32)) {
            var %rgba = %rgba $rgb(%rgbs)
            var %rgbi = %rgbi %i
            drawreplace -r @preview %o %rgbs
            break
          }
          inc %rgbs
        }
      }
      elseif (%o != %r) drawreplace -r @preview %o %r
      did -a preaux 2 %i 0 16
      inc %i
    }
    var %i = 1
    while ($gettok(%rgba,%i,32)) {
      var %o = $rgb( [ $ifmatch ] )
      var %r = $rgb( [ $gettok(%p.rgbcolors,$gettok(%rgbi,%i,32),32) ] )
      drawreplace -r @preview %o %r
      inc %i
    }
    dialog -x preaux
    drawsave @preview %fpreview
    if ($dialog(mts)) && ($1 == small) {
      showpre %fpreview
      did -v mts 14
      did -e mts 37
    }
    else showprel %fpreview
    .remove $mts.path(preview.mts)
    window -c @preview
    window -c @pretext
    if (%unload) .unload -rs %p.script
  }
}

alias mtsload {
  if ($isfile($2-)) {
    if ($mtsget($2-,mtsversion) > $mts.version) {
      var %v = $input(This theme is meant for MTS format $ifmatch $+ . This theme loader is meant for $mts.version $+ . Procced?,yvq,Clone Scan)
      if (%v == $no) return
    }
    if ($mtsret(main,minimize)) wins -n
    if ($mtsret(main,clear)) clearall
    dialog -hm preaux preaux
    dialog -t preaux MTS load
    did -a preaux 1 Generating source
    mtssch $1-
    if ($isfile($mts.path(current.mts))) .remove $mts.path(current.mts)
    .savebuf @mtsp1 $mts.path(current.mts)
    window -c @mtsp1
    if ($window(@mtsp2)) window -c @mtsp2
    did -a preaux 2 1 0 9
    var %f = $mts.path(current.mts)
    current.unload
    if ($load.aux5(colors)) {
      did -ra preaux 1 Loading colors
      hadd mts basecolors $mtsget(%f,basecolors)
      if ($mtsget(%f,rgbcolors)) {
        hadd mts rgbcolors $ifmatch
        if ($version >= 6.1) loadc1 $mtsh(rgbcolors)
        else {
          var %i = 15
          while (%i >= 0) {
            colour %i $rgb( [ $gettok($mtsh(rgbcolors),$calc(%i + 1),32) ] )
            dec %i
          }
        }
      }
      else rgbrst
      if ($mtsget(%f,colors)) {
        hadd mts colors $ifmatch
        if ($version >= 6.1) loadc2 $mtsh(colors)
        else {
          load.aux 1 background
          load.aux 2 action text
          load.aux 3 ctcp text
          load.aux 4 highlight text
          load.aux 5 info text
          load.aux 6 info2 text
          load.aux 7 invite text
          load.aux 8 join text
          load.aux 9 kick text
          load.aux 10 mode text
          load.aux 11 nick text
          load.aux 12 normal text
          load.aux 13 notice text
          load.aux 14 notify text
          load.aux 15 other text
          load.aux 16 own text
          load.aux 17 part text
          load.aux 18 quit text
          load.aux 19 topic text
          load.aux 20 wallops text
          load.aux 21 whois
          load.aux 22 editbox
          load.aux 23 editbox text
          load.aux 24 listbox
          load.aux 25 listbox text
          load.aux 26 $iif($version >= 6.1,gray,grayed) text
          load.aux 27 title text
          load.aux 28 inactive
        }
      }
      else colorrst
    }
    else {
      rgbrst
      colorrst
    }
    did -a preaux 2 2 0 9
    clinerst
    did -ra preaux 1 Loading nickcolors
    if ($mtsret(options,nickcolors)) {
      load.aux7 m0 yourself
      load.aux7 om0 autoop
      load.aux7 vm0 autovoice
      load.aux7 pm0 protect
      load.aux7 ym0 notify
      load.aux7 im0 ignore
      load.aux7 m0 owner .
      load.aux7 m0 op @
      load.aux7 m0 hop %
      load.aux7 m0 voice +
      load.aux7 m0 regular
    }
    elseif ($load.aux5(nicks)) {
      if ($mtsget(%f,clineme) != $null) .cnick -m0 $eval($me,0) $ifmatch
      if ($mtsget(%f,clinefriend) != $null) {
        .cnick -om0 * $ifmatch
        .cnick -vm0 * $ifmatch
        .cnick -pm0 * $ifmatch
        .cnick -ym0 * $ifmatch
      }
      if ($mtsget(%f,clineenemy) != $null) .cnick -im0 * $ifmatch
      load.aux6 clineowner . %f
      load.aux6 clineop @ %f
      load.aux6 clinehop % %f
      load.aux6 clinevoice + %f
      if ($mtsget(%f,clineregular) != $null) .cnick -m0 * $ifmatch
    }
    hadd mts clinecharowner $mtsget(%f,clinecharowner)
    hadd mts clineCharop $mtsget(%f,clinecharop)
    hadd mts clineCharhop $mtsget(%f,clinecharhop)
    hadd mts clineCharvoice $mtsget(%f,clinecharvoice)
    hadd mts clineCharregular $mtsget(%f,clinecharregular)
    did -a preaux 2 3 0 9
    hadd mts pre $load.aux2($mtsget(%f,prefix))
    hadd mts parentext $load.aux2($mtsget(%f,parentext))
    tsrst
    if ($load.aux5(timestamp)) {
      did -ra preaux 1 Loading timestamp
      hadd mts timestamp $mtsget(%f,timestamp)
      hadd mts timestampformat $load.aux2($mtsget(%f,timestampformat))
      .timestamp on
      if ($mtsh(timestamp)) && ($mtsh(timestamp) != on) && ($mtsh(timestamp) != off) {
        hadd mts timestampformat $load.aux2($ifmatch)
        .timestamp -f $mtsh(timestampformat)
      }
      elseif ($mtsh(timestamp) == on) .timestamp -f $iif($mtsh(timestampformat),$ifmatch,[HH:nn])
      else .timestamp off
    }
    did -a preaux 2 4 0 9
    if ($load.aux5(fonts)) {
      did -ra preaux 1 Loading fonts
      remini mirc.ini fonts
      var %j = 1
      while ($scon(%j)) {
        scon %j
        if ($mtsget(%f,fontdefault)) {
          hadd mts fontdefault $mtsget(%f,fontdefault)
          .font -s $load.aux3($mtsh(fontdefault))
        }
        else {
          .font -s "fixedsys" 9
          hdel mts fontdefault
        }
        var %t = fixedsys,9
        if ($mtsget(%f,fontchan)) {
          hadd mts fontchan $mtsget(%f,fontchan)
          var %font = $load.aux3($mtsh(fontchan))
        }
        else {
          var %font = $load.aux3(%t)
          hdel mts fontchan
        }
        writeini mirc.ini fonts fchannel $iif($mtsh(fontchan),$ifmatch,%t)
        var %i = 1
        while ($chan(%i)) {
          .font $chan(%i) %font
          inc %i
        }
        if ($mtsget(%f,fontquery)) {
          hadd mts fontquery $mtsget(%f,fontquery)
          var %font = $load.aux3($mtsh(fontquery))
        }
        else {
          var %font = $load.aux3(%t)
          hdel mts fontquery
        }
        writeini mirc.ini fonts fquery $iif($mtsh(fontquery),$ifmatch,%t)
        writeini mirc.ini fonts fchat $iif($mtsh(fontquery),$ifmatch,%t)
        var %i = 1
        while ($query(%i)) {
          .font $query(%i) %font
          inc %i
        }
        var %i = 1
        while ($chat(%i)) {
          .font = $+ $chat(%i) %font
          inc %i
        }
        inc %j
      }
    }
    else fontrst
    did -a preaux 2 5 0 9
    bgrst
    hadd mts file $2-
    if ($load.aux5(pictures)) {
      did -ra preaux 1 Loading pictures
      remini mirc.ini background
      var %j = 1
      while ($scon(%j)) {
        scon %j
        hadd mts imagestatus $mtsget(%f,imagestatus)
        if ($mtsh(imagestatus)) background -s $+ $load.aux4($ifmatch)
        hadd mts imagechan $mtsget(%f,imagechan)
        if ($img.aux4($mtsh(imagechan))) {
          var %i = 1
          while ($chan(%i)) {
            background - $+ $img.aux($mtsh(imagechan)) $chan(%i) $img.aux2($mtsh(imagechan))
            inc %i
          }
          writeini mirc.ini background wchannel $img.aux3($mtsh(imagechan))
        }
        hadd mts imagequery $mtsget(%f,imagequery)
        if ($img.aux4($mtsh(imagequery))) {
          var %i = 1
          while ($query(%i)) {
            background - $+ $img.aux($mtsh(imagequery)) $query(%i) $img.aux2($mtsh(imagequery))
            inc %i
          }
          var %i = 1
          while ($chat(%i)) {
            background - $+ $img.aux($mtsh(imagequery)) $+(=,$chat(%i)) $img.aux2($mtsh(imagequery))
            inc %i
          }
          writeini mirc.ini background wquery $img.aux3($mtsh(imagechan))
          writeini mirc.ini background wchat $img.aux3($mtsh(imagechan))
        }
        hadd mts imagemirc $mtsget(%f,imagemirc)
        if ($img.aux4($mtsh(imagemirc))) background -m $+ $load.aux4($mtsh(imagemirc))
        if (!$dialog(toolbar)) {
          hadd mts imagebuttons $mtsget(%f,imagebuttons)
          if ($isfile($nofile($mtsh(file)) $+ $mtsh(imagebuttons))) background -u $img.aux2($mtsh(imagebuttons))
          hadd mts imagetoolbar $mtsget(%f,imagetoolbar)
          if ($img.aux4($mtsh(imagetoolbar))) background -l $+ $load.aux4($mtsh(imagetoolbar))
        }
        hadd mts imageswitchbar $mtsget(%f,imageswitchbar)
        if ($img.aux4($mtsh(imageswitchbar))) background -h $+ $load.aux4($mtsh(imageswitchbar))
        inc %j
      }
    }
    did -a preaux 2 6 0 7
    srst
    if ($mtsget(%f,script)) {
      did -ra preaux 1 Loading scriped events
      hadd mts script $nofile($mtsh(file)) $+ $mtsget(%f,script)
      if ($isfile($mtsh(script))) .load -rs " $+ $mtsh(script) $+ "
    }

    hadd -m mts current %f
    did -a preaux 2 7 0 7
    hadd mts load $load.aux2($mtsget(%f,load))
    hadd mts unload $load.aux2($mtsget(%f,unload))
    if ($mtsh(load)) {
      set -u %:echo echo $color(other) -s
      if ($gettok($mtsh(load),1,32) == !script) $gettok($mtsh(load),2-,32)      
      else %:echo $mtsh(load)
    }
    if ($dialog(mts)) did -e mts 21
    dialog -x preaux
    if ($mtsret(main,minimize)) wins -r
    hsave -o mts $mts.path(mts.ah)
  }
}

alias mtsunload {
  if ($mtsret(main,minimize)) wins -n
  if ($mtsret(main,clear)) clearall
  current.unload
  dialog -hm preaux preaux
  did -a preaux 1 Unloading MTS Theme
  colorrst
  did -a preaux 2 1 0 8
  clinerst
  did -a preaux 2 2 0 8
  rgbrst
  did -a preaux 2 3 0 8
  bgrst
  did -a preaux 2 4 0 8
  fontrst
  did -a preaux 2 5 0 8
  tsrst
  did -a preaux 2 6 0 8
  srst
  did -a preaux 2 7 0 8
  hdel -w mts *
  if ($isfile($mts.path(current.mts))) .remove $mts.path(current.mts)
  did -a preaux 2 8 0 8
  if ($dialog(mts)) did -b mts 21
  dialog -x preaux
  if ($mtsret(main,minimize)) wins -r
  hsave -o mts $mts.path(mts.ah)
}

alias mtsvars {
  set -nu %:echo $gettok($1-,1,9)
  set -nu %::me $me
  set -nu %::server $server
  set -nu %::port $port
  set -nu %::pre $pre
  set -nu %::target $target
  set -u %::c1 $bc(1)
  set -u %::c2 $bc(2)
  set -u %::c3 $bc(3)
  set -u %::c4 $bc(4)
  set -nu %::timestamp $time($mtsh(timestampformat))
  if ($numeric) {
    set -nu %::numeric $numeric
    var %t = $gettok($gettok($1-,2,9),1,32)
    set -nu %::value %t
    set -nu %::nick %t
    set -nu %::chan %t
    set -nu %::fromserver $nick
    set -nu %::isoper is not
    set -nu %::isregd is not
    set -nu %::text $gettok($1-,2,9)
  }
}

alias -l theme.parse {
  var %t = $replace($1,<pre>,%::pre,<timestamp>,%::timestamp,<c1>,%::c1,<c2>,%::c2,<c3>,%::c3,<c4>,%::c4)
  var %t = $replace(%t,<me>,%::me,<server>,%::server,<port>,%::port,<nick>,%::nick,<chan>,%::chan,<address>,%::address)
  var %t = $replace(%t,<cmode>,%::cmode,<cnick>,%::cnick,<target>,%::target,<knick>,%::knick,<kaddress>,%::kaddress,<newnick>,%::newnick)
  var %t = $replace(%t,<modes>,%::modes,<ctcp>,%::ctcp,<numeric>,%::numeric,<value>,%::value,<fromserver>,%::fromserver,<users>,%::users)
  var %t = $replace(%t,<away>,%::away,<realname>,%::realname,<isoper>,%::isoper,<operline>,%::operline,<isregd>,%::isregd)
  var %t = $replace(%t,<wserver>,%::wserver,<serverinfo>,%::serverinfo,<idletime>,%::idletime,<signontime>,%::signontime,<iaddress>,%::iaddress,<naddress>,%::naddress,<raddress>,%::raddress)
  var %t = $replace(%t,<ts>,,<lt>,<,<gt>,>,<parentext>,%::parentext,<text>,%::text)
  return %t
}

alias theme.text {
  if (%::text) set -nu %::parentext $replace($mtsh(parentext),<text>,%::text)
  if ($1) var %t = $mtsget($mtsh(current),$1)
  else var %t = $eval(%mts.event,2)
  if (!%t) && (raw. isin $1) var %t = $mtsget($mtsh(current),raw.other)
  if (!%t) return
  var %t = $theme.parse(%t)
  if ($gettok(%t,1,32) != !script) %:echo %t %:comments
  else {
    if (!$gettok(%t,2,32)) {
      if (raw. isin $1) halt
    }
    else $gettok(%t,2-,32)
  }
  haltdef
}

alias cmode {
  var %t = $left($remove($nick($2,$1).pnick,$1),1)
  if (%t == .) && ($mtsh(clinecharowner)) var %t = $mtsh(clinecharowner)
  elseif (%t == @) && ($mtsh(clineCharop)) var %t = $mtsh(clineCharop)
  elseif (%t == %) && ($mtsh(clineCharhop)) var %t = $mtsh(clineCharhop)
  elseif (%t == +) && ($mtsh(clineCharvoice)) var %t = $mtsh(clineCharvoice)
  elseif ($mtsh(clineCharregular)) var %t = $mtsh(clineCharregular)
  return $+(,%t,)
}

alias mts.event {
  if (!$mtsh(current)) || (!$1) return
  set -nu %mts.event $read($mtsh(current),ns,$1)
  if (%mts.event) return 1
}

alias pre if ($mtsh(pre)) return $ifmatch

alias bc if ($1 isnum) && ($mtsh(basecolors)) return  $+ $gettok($mtsh(basecolors),$1,44)

alias cmdchar return $readini(mirc.ini,text,commandchar)

alias -l img.aux return $lower($replace($left($gettok($1,1,32),1),s,r))

alias -l img.aux2 return " $+ $nofile($mtsh(file)) $+ $iif($gettok($1,2,32),$ifmatch,$1) $+ "

alias -l img.aux3 {
  var %t = $gettok($1,1,32)
  if (%t == center) var %t = 0
  elseif (%t == fill) var %t = 1
  elseif (%t == normal) var %t = 2
  elseif (%t == stretch) var %t = 3
  elseif (%t == tile) var %t = 4
  elseif (%t == photo) var %t = 5
  return $nofile($mtsh(file)) $+ $gettok($1,2,32) $+ , $+ %t
}

alias -l img.aux4 return $isfile($nofile($mtsh(file)) $+ $gettok($1,2,32))

alias describe {
  if ($1 != $null) && ($1 ischan) || ($query($1)) || ($left($1,1) == $chr(61)) {
    if ($show) {
      if ($mts.event($iif($active ischan,actionchanself,actionqueryself))) {
        mtsvars echo $color(own) -tm $1
        set -nu %::nick $active
        set -nu %::chan $active
        set -nu %::address $address($me,5)
        if ($active ischan) set -u %::cmode $cmode($me,$active)
        set -u %::cnick $cnick($me).color
        set -nu %::me $+(,%::cnick,$me,)
        set -nu %::text $2-
        var %m = .describe
        theme.text
      }
      else var %m = describe
    }
    else var %m = .describe
    %m $1-
  }
}

alias me if ($is.input($1)) describe $active $1-

alias msg {
  if ($2 != $null) {
    if ($show) {
      if (!$window($1)) var %t = textmsgself
      elseif ($1 ischan) var %t = textchanself
      else var %t = textqueryself
      if ($mts.event(%t)) {
        mtsvars echo $color(own) $iif(%t == textmsgself,-ta,-tm $1)
        set -nu %::nick $1
        set -nu %::chan $1
        set -nu %::address $address($me,5)
        if ($1 ischan) set -u %::cmode $cmode($me,$1)
        set -u %::cnick $cnick($me).color
        set -nu %::me $+(,%::cnick,$me,)
        set -nu %::text $2-
        var %m = .msg
        theme.text
      }
      else var %m = msg
    }
    else var %m = .msg
    %m $1-
  }
}

alias amsg {
  if ($1 != $null) {
    am.aux amsg textchanself $1-
    %m $1-
  }
}

alias ame {
  if ($1 != $null) {
    am.aux ame actionchanself $1-
    %m $1-
  }
}

alias say if ($is.input($1)) msg $active $1-

alias notice {
  if ($2 != $null) {
    if ($show) {
      if ($mts.event($iif($left($1,1) == $chr(35),noticechanself,noticeself))) {
        mtsvars echo $color(own) -ta
        set -nu %::nick $1
        set -nu %::chan $1
        set -nu %::address $address($me,5)
        if ($1 ischan) set -u %::cmode $cmode($me,$1)
        set -u %::cnick $cnick($me).color
        set -nu %::me $+(,%::cnick,$me,)
        set -nu %::text $2-
        var %m = .notice
        theme.text
      }
      else var %m = notice
    }
    else var %m = .notice
    %m $1-
  }
}

alias dns {
  if ($mts.event(dns)) {
    if ($left($1,1) == -) var %t = $2
    else var %t = $1
    mtsvars echo $color(other) -a
    set -u %::nick %t
    set -u %::address %t
    .dns $1-
    if ($show) theme.text
  }
  else $iif($show,dns,.dns) $1-
}

alias ctcp {
  if ($2 != $null) {
    ctcp.aux ctcp $1-
    %m $iif($2 == PING,$1 $2 $ctime,$1-)
  }
}

alias ctcpreply {
  if ($2 != $null) {
    ctcp.aux ctcpreply $1-
    %m $1-
  }
}

alias -l mtspop {
  mtspopups New mtspop 9 9
  mtspop.aux Add $cr mtsadd
  mtspop.aux Edit $cr mtsedit
  mtspop.aux Remove $cr mtsdel
  mtspop.aux 
  mtspop.aux Preview $cr mtspre $mpre(small)
  mtspop.aux Load $cr mtsload $sch $read($mts.path(mts.tl),n,$calc($did(mts,1).sel - 1))
  mtspop.aux 
  mtspop.aux Show info $cr mtsinfo $+(",$read($mts.path(mts.tl),n,$calc($did(mts,1).sel - 1)),")
  var %t = $mtspopups(Popup,mtspop + $mouse.dx $mouse.dy)
  if ($gettok(%t,1,32) == OK) $gettok(%t,4-,32)
}

alias -l mtspop.aux mtspopups AddItem mtspop end + 0 0 $1-

alias -l setmdxpath {
  var %t = $$sdir($scriptdir,Set MDX path,Ok)
  if ($isfile(%t $+ mdx.dll)) && ($isfile(%t $+ ctl_gen.mdx)) && ($isfile(%t $+ views.mdx)) writeini $mts.path(mts.ini) main mdx %t
  else var %null = $input(MDX files are missing. You need at least mdx.dll $+ $chr(44) ctl_gen.mdx and views.mdx,o,Theme loader)
}

alias setpoppath {
  var %t = $$sfile($scriptdir $+ *.dll,Set Popups.dll path,Ok)
  if ($isfile(%t)) writeini $mts.path(mts.ini) main popups %t
}

alias -l mts.path return $+(",$scriptdir,$1,")

alias -l mtsh return $hget(mts,$1)

alias -l mtsret return $readini($mts.path(mts.ini),$1,$2)

alias -l mtsinil if ($mtsret(main,$1)) did -c mts $2

alias -l mpre return $1 $sch $+(",$read($mts.path(mts.tl),n,$calc($did(mts,1).sel - 1)),")

alias -l mtsini {
  if ($did(mts,$2).state) did -u mts $2
  else did -c mts $2
  writeini $mts.path(mts.ini) main $1 $did(mts,$2).state
}

alias -l dm {
  if ($1) {
    if ($dialog(mtsinfo)) mtsinfo $+(",$read($mts.path(mts.tl),n,$1),")
    did -ra mts 4 Default
    var %i = 1
    var %t = scheme $+ 1
    while ($mtsget($1,%t)) {
      did -a mts 4 $mtsget($1,%t)
      inc %i
      var %t = scheme $+ %i
    }
    did -c mts 4 1
    if (%i > 1) did -e mts 4
    else did -b mts 4
  }
}

alias -l sch return $iif($did(mts,4).sel == 1,mts,$+(scheme,$calc($did(mts,4).sel - 1)))

alias -l clearinfo {
  if ($dialog(mtsinfo)) {
    did -ra mtsinfo 2 Info on theme: N/A
    did -ra mtsinfo 4 Name: N/A
    did -ra mtsinfo 5 Author: N/A
    did -ra mtsinfo 6 N/A
    did -ra mtsinfo 8 N/A
    did -ra mtsinfo 9 MTS Version: N/A
    did -ra mtsinfo 11 N/A
  }
}

alias -l mtsinfo.aux return $iif($mtsget($1,$2),$ifmatch,N/A)

alias -l showpre {
  writeini $mts.path(mts.ini) main preview $1-
  did -ra mts 12 Preview: $deltok($nopath($1-),-1,45)
  did -h mts 22
  did -g mts 14 $1-
}

alias -l showprel {
  if ($dialog(lpre)) dialog -x lpre lpre
  dialog -hm lpre lpre
  did -g lpre 4 $1-
  did -ra lpre 2 Preview: $deltok($nopath($1-),-1,45)
}

alias -l mtssch {
  window -h @mtsp1
  .loadbuf -tmts @mtsp1 $shortfn($2-)
  if ($1 != mts) && ($read($2-,wn,$+($chr(91),$1,$chr(93)))) {
    window -h @mtsp2
    .loadbuf -t $+ $1 @mtsp2 $shortfn($2-)
    var %i = 1
    while ($line(@mtsp2,%i)) {
      var %w = $gettok($line(@mtsp2,%i),1,32) *
      if (%w != *) {
        if ($fline(@mtsp1,%w)) rline @mtsp1 $fline(@mtsp1,%w) $line(@mtsp2,%i)
        else aline @mtsp1 $line(@mtsp2,%i)
      }
      inc %i
    }
  }
}

alias -l mtspre.aux return $replace($1,<c1>,%::c1,<c2>,%::c2,<c3>,%::c3,<c4>,%::c4)

alias -l mtspre.aux2 {
  var %t = $mtsget($3-,$2)
  if (!%t) return
  else {
    set -u %:echo aline @pretext $1
    var %t = $theme.parse(%t)
    if ($gettok(%t,1,32) == !script) {
      if ($gettok(%t,2-,32)) $ifmatch
    }
    else aline @pretext $1 %t
  }
}

alias -l optaux if ($mtsret(options,$1)) did -c mtsopt $2

alias -l optaux2 { 
  did -a mtsopt 22 $1
  hadd -m mtsopt $1 $mtsret(options,$1)
}

alias -l optaux3 mtsmdx SetColor $dname 23 background $color($hget(mtsopt,$1))

alias -l optaux4 writeini $mts.path(mts.ini) options $1 $did(mtsopt,$2).state

alias -l optaux5 writeini $mts.path(mts.ini) options $1 $hget(mtsopt,$1)

alias -l current.unload {
  if ($mtsh(unload)) {
    set -u %:echo echo $color(other) -s
    if ($gettok($mtsh(unload),1,32) == !script) $gettok($mtsh(unload),2-,32)      
    else %:echo $mtsh(unload)
  }
}

alias -l load.aux {
  if ($gettok($mtsh(colors),$1,44) != $null) color $2- $ifmatch
  elseif ($1 == 28) color inactive $color(editbox)
}

alias -l load.aux2 return $replace($1,<c1>,$bc(1),<c2>,$bc(2),<c3>,$bc(3),<c4>,$bc(4),<pre>,$pre,<ts>,,<lt>,<,<gt>,>)

alias -l load.aux3 return " $+ $gettok($gettok($1,1,44),1,59) $+ " $gettok($1,2,44)

alias -l load.aux4 return $img.aux($1) $img.aux2($1)

alias -l load.aux5 return $mtsret(options,$1)

alias -l load.aux6 if ($mtsget($3-,$1) != $null) .cnick -m0 * $ifmatch $2

alias -l load.aux7 .cnick - $+ $1 $iif($2 == yourself,$eval($me,0),*) $mtsret(options,$2) $3

alias -l loadc1 {
  var %i = 1
  while ($gettok($1-,%i,32)) {
    var %t = %t $+ , $+ $rgb( [ $ifmatch ] )
    inc %i
  }
  writeini mirc.ini palettes n0 $remfirst(%t,1)
}

alias -l loadc2 {
  var %t = $1-
  if ($numtok(%t,44) == 26) var %t = %t $+ , $+ $gettok(%t,-1,44)
  if ($numtok(%t,44) == 27) var %t = %t $+ , $+ $gettok(%t,22,44)
  writeini mirc.ini colors n0 mIRC Classic, $+ %t
  .color -ls mIRC Classic
}

alias -l rgbrst {
  if ($mtsh(rgbcolors)) {
    if ($version >= 6.1) loadc1 $rgbdef
    else {
      var %i = 15
      while (%i >= 0) {
        colour -r %i
        dec %i
      }
    }
    hdel mts rgbcolors
  }
}

alias -l colorrst {
  if ($mtsh(colors)) {
    if ($version >= 6.1) loadc2 $cdef
    else {
      colour background 0
      colour action text 6
      colour ctcp text 4
      colour highlight text 5
      colour info text 2
      colour info2 text 3
      colour invite text 3
      colour join text 3
      colour kick text 3
      colour mode text 3
      colour nick text 3
      colour normal text 1
      colour notice text 5
      colour notify text 7
      colour other text 6
      colour own text 1
      colour part text 3
      colour quit text 2
      colour topic text 3
      colour wallops text 5
      colour whois 1
      colour editbox 0
      colour editbox text 1
      colour listbox 0
      colour listbox text 1
      colour $iif($version >= 6.1,gray,grayed) text 15
      colour title text 7
      colour inactive 0
    }
    hdel mts colors
  }
}

alias -l clinerst {
  .cnick -r $eval($me,0)
  while ($cnick(0)) .cnick -r *
}

alias -l tsrst {
  .timestamp on
  .timestamp -f [HH:nn]
  hdel -w mts timestamp*
}

alias -l bgrst {
  var %j = 1
  while ($scon(%j)) {
    scon %j
    background -xs
    background -xm
    background -xl
    background -xu
    background -xh
    var %i = 1
    while ($chan(%i)) {
      background -x $chan(%i)
      inc %i
    }
    var %i = 1
    while ($query(%i)) {
      background -x $query(%i)
      inc %i
    }
    var %i = 1
    while ($chat(%i)) {
      background -x $+(=,$chat(%i))
      inc %i
    }
    inc %j
  }
  remini mirc.ini background
  writeini mirc.ini background wquery none
  writeini mirc.ini background wchat none
  writeini mirc.ini background wchannel none
  hdel -w mts image*
}

alias -l srst {
  if ($mtsh(script)) .unload -rsn " $+ $mtsh(script) $+ "
  hdel mts script
}

alias -l fontrst {
  var %j = 1
  while ($scon(%j)) {
    scon %j
    var %t = "fixedsys" 9
    .font -s %t
    var %i = 1
    while ($chan(%i)) {
      .font $chan(%i) %t
      inc %i
    }
    while ($read(mirc.ini,wn,f#*)) {
      write -dl $readn mirc.ini
    }
    var %i = 1
    while ($query(%i)) {
      .font $query(%i) %t
      inc %i
    }
    var %i = 1
    while ($chat(%i)) {
      .font = $+ $chat(%i) %t
      inc %i
    }
    inc %j
  }
  remini mirc.ini fonts
  writeini mirc.ini fonts fchannel fixedsys,9
  writeini mirc.ini fonts fquery fixedsys,9
  writeini mirc.ini fonts fchat fixedsys,9
  hdel -w mts font*
}

alias -l cdef return 0,6,4,5,2,3,3,3,3,3,3,1,5,7,6,1,3,2,3,5,1,0,1,0,1,15,6,0

alias -l rgbdef return 255,255,255 0,0,0 0,0,128 0,144,0 255,0,0 128,0,0 160,0,160 255,128,0 255,255,0 0,255,0 0,144,144 0,255,255 0,0,255 255,0,255 128,128,128 208,208,208

alias -l wins {
  if ($left($1,1) == $chr(45)) {
    var %i = 1
    while ($window(*,%i)) {
      var %t = $window(*,%i)
      window $1 $iif($left(%t,1) == $chr(61),%t,$+(",%t,"))
      inc %i
    }
  }
}

alias -l loopt {
  var %i = 1
  while ($comchan($1,%i)) {
    mtsvars echo $color($event) -t $comchan($1,%i)
    theme.text
    inc %i
  }
}

alias -l tjp {
  if ($mts.event($1)) {
    if ($event == join) && ($nick == $me) {
      if ($mtsret(options,names)) hadd -m join $+(names.,$chan,$cid) 1
      if ($mtsret(options,chaninfo)) hadd -m join $+(topic.,$chan,$cid) 1
    }
    mtsvars echo $color($event) -t $chan
    set -nu %::nick $nick
    set -nu %::address $iif($address,$ifmatch,N/A)
    set -nu %::chan $chan
    set -nu %::text $2-
    theme.text
  }
}

alias -l mts.inp {
  if ($mtsh(current)) && ($left($1,1) != $cmdchar) {
    say $1-
    halt
  }
}

alias -l mts.tan {
  if ($mtsh(current)) {
    if ($chan) {
      var %t = -tlm $chan    
      if ($event == text) var %e = textchan
      elseif ($event == action) var %e = actionchan
      else var %e = noticechan
      set -nu %::chan $chan
      set -u %::cmode $cmode($nick,$chan)
      set -u %::cnick $nick($chan,$nick).color
    }
    else {
      var %t = $iif($event != notice,$iif($query($nick),-tlm $nick,-tldm),-tlam)
      if ($event == text) var %e = $iif($query($nick),textquery,textmsg)
      elseif ($event == action) var %e = actionquery
      else var %e = notice
      set -u %::cnick $cnick($nick).color
    }
    if ($mts.event(%e)) {
      if ($highlight($nick).nicks) && ($highlight) {
        if ($highlight($nick).sound != none) {
          var %s = $ifmatch
          $iif(%s == beep,%s,.splay -wmp $+(",%s,"))
        }
        if ($highlight($nick).color) var %c = $ifmatch - 1
        if ($highlight($nick).flash) flash $+(-r,$ifmatch) $highlight($nick).message
      }
      mtsvars echo $iif(%c != $null,%c,$color($iif($event == text,normal,$event))) %t
      set -nu %::nick $+(,%::cnick,$nick,)
      set -nu %::address $iif($address,$ifmatch,N/A)
      set -nu %::text $1-
      theme.text
    }
  }
}

alias -l uno {
  if ($mts.event($event)) {
    mtsvars echo $color(notify) -at
    set -nu %::nick $nick
    set -nu %::address $notify($nick).addr
    set -nu %::text $notify($nick).note
    theme.text
  }
}

alias -l am.aux {
  if ($show) {
    if ($mts.event($2)) {
      set -nu %::address $address($me,5)
      set -u %::cnick $cnick($me).color
      set -nu %::text $3-
      set -u %m . $+ $1
      var %i = 1
      while ($chan(%i)) {
        mtsvars echo $color(own) -t $chan(%i)
        set -nu %::me $+(,%::cnick,$me,)
        set -u %::cmode $cmode($me,$chan(%i))
        set -nu %::chan $chan(%i)
        theme.text $2
        inc %i
      }
    }
    else set -u %m $1
  }
  else set -u %m . $+ $1
}

alias is.input {
  if ($1 != $null) && (($active ischan) || ($query($active)) || ($left($active,1) == $chr(61))) return 1
}

alias -l ctcp.aux {
  if ($show) {
    if ($mts.event($+($1,$iif($left($1,1) == $chr(35),chanself,self)))) {
      mtsvars echo $color(own) -at
      set -u %::nick $2
      set -u %::chan $2
      set -u %::ctcp $upper($3)
      set -u %::text $4-
      set -nu %m . $+ $1
      theme.text
    }
    else set -nu %m $1
  }
  else set -nu %m . $+ $1
}

alias -l raw.aux {
  if ($mtsh(current)) && (!$halted) {
    if ($mtsret(options,welcome)) && ($numeric >= 001) && ($numeric <= 005) halt
    mtsvars echo $color(other) $1 $+ $chr(9) $+ $2-
    theme.text $+(raw.,$numeric)
    halt
  }
}

alias -l raw.aux2 {
  if ($mtsh(current)) && (!$halted) {
    if ($hget(lusers,$cid)) {
      if ($numeric == 266) hdel lusers $cid
      halt
    }
    mtsvars echo $color(other) -s $+ $chr(9) $+ $3-
    set -u %::users $gettok($3-,$1,32)
    set -u %::value $gettok($3-,$2,32)
    theme.text $+(raw.,$numeric)
    halt
  }
}

alias -l raw.aux3 {
  if ($mtsh(current)) && (!$halted) {
    hadd -m $+(whois.,$2,$cid) $numeric $3-
    if ($mtsget($mtsh(current),$+(raw.,$numeric))) {
      mtsvars echo $color(whois) -a $+ $chr(9) $+ $2-
      set -u %::nick $2
      set -u %::text $3-
      theme.text $+(raw.,$numeric)
    }
    halt
  }
}

alias -l raw.aux4 {
  if ($mtsh(current)) && (!$halted) {
    mtsvars echo $color(whois) -a $+ $chr(9) $+ $2-
    set -u %::nick $2
    set -u %::chan $3
    theme.text $+(raw.,$numeric)
    halt
  }
}

alias -l aux.318.369 {
  if ($mtsh(current))  && (!$halted) {
    mtsvars echo $color(whois) -a $+ $chr(9) $+ $2-
    if ($mtsget($mtsh(current),whois)) {
      var %i = 1
      while ($gettok($2,%i,44)) {
        set -u %::nick $gettok($2,%i,44)
        var %t = $hget($+(whois.,%::nick,$cid),$iif($numeric == 318,311,314))
        if (%t) {
          set -u %::address $gettok(%t,1,32) $+ @ $+ $gettok(%t,2,32)
          set -u %::realname $gettok(%t,4-,32)
          set -u %::country $country($gettok(%t,2,32))
          set -u %::away $hget($+(whois.,%::nick,$cid),301)
          set -u %::text $hget($+(whois.,%::nick,$cid),301)
          set -u %::isregd is $iif(!$hget($+(whois.,%::nick,$cid),307),not)
          var %t = $hget($+(whois.,%::nick,$cid),317)
          set -u %::idletime $gettok(%t,1,32)
          set -u %::signontime $gettok(%t,2,32)
          set -u %::chan $hget($+(whois.,%::nick,$cid),319)
          var %t = $hget($+(whois.,%::nick,$cid),312)
          set -u %::wserver $gettok(%t,1,32)
          set -u %::serverinfo $gettok(%t,2,32)
          var %t = $hget($+(whois.,%::nick,$cid),313)
          set -u %::isoper is $iif(!%t,not)
          set -u %::operline %t
          theme.text $iif($numeric == 318,whois,whowas)
        }
        inc %i
      }
    }
    if (%::address) || ($hget($+(whois.,$gettok($2,1,44),$cid),$iif($numeric == 318,311,314))) theme.text $+(raw.,$numeric)
    hfree -w $+(whois.*,$cid)
    halt
  }
}
